import * as React from 'react';
export declare type Params<T extends (...args: never[]) => unknown> = T extends (...args: infer P) => any ? P : never;
export declare type RetType<T extends (...args: never[]) => unknown> = T extends (...args: never[]) => infer R ? R : any;
export declare type DropFirst<T extends any[]> = ((...args: T) => any) extends (arg: any, ...rest: infer U) => any[] ? U : T;
export declare type Tail<T> = T extends Array<any> ? ((...args: T) => never) extends ((a: any, ...args: infer R) => never) ? R : never : never;
declare type ContextReference<TState, TContexts extends Contexts> = {
    state: TState;
    setState: React.Dispatch<React.SetStateAction<TState>>;
    stores: InferStores<TContexts>;
};
declare type Action<TState, TContexts extends Contexts, TArgs extends never[] = never[], TReturn = any> = (contextReference: ContextReference<TState, TContexts>, ...args: TArgs) => TReturn;
declare type Actions<TState, TContexts extends Contexts> = {
    [key: string]: Action<TState, TContexts>;
};
declare type MappedActions<TState, TContexts extends Contexts, TActions extends Actions<TState, TContexts>> = {
    [P in keyof TActions]: (...args: DropFirst<Params<TActions[P]>>) => RetType<TActions[P]>;
};
declare type Store<TState, TContexts extends Contexts, TActions extends Actions<TState, TContexts>> = TActions extends undefined ? TState : TState & MappedActions<TState, TContexts, TActions>;
declare type Context<T = any> = React.Context<T>;
declare type Contexts = {
    [key: string]: Context;
};
export declare type Params1<T extends (...args: never[]) => unknown> = T extends (...args: infer P) => any ? P : never;
declare type InferStore<TContext extends React.Context<any>> = TContext extends React.Context<infer TStore> ? TStore : never;
declare type InferStores<TContexts extends Contexts> = {
    [P in keyof TContexts]: InferStore<TContexts[P]>;
};
export default function createStoreContext<TState, TContexts extends Contexts, TActions extends Actions<TState, TContexts> = {}>(initialState: TState, actions?: TActions, contexts?: TContexts): [React.Context<Store<TState, TContexts, TActions>>, React.FC];
export {};
